var stage; //Is the equivalent of stage in AS3; we'll add "children" to it

// Graphics

var queue;
//[Background]
 
var bg; //The background graphic
 
//[Title View]
  
 
var main; //The Main Background
var startB; //The Start button in the main menu
var creditsB; //The credits button in the main menu
 
//[Credits]
 
 
var credits; //The Credits screen
 
//[Game View]
 
 
var masterPlayer; //The player paddle graphic
var ball; //The ball graphic
var slavePlayer; //The CPU paddle
var win; //The winning popup
var lose; //The losing popup

var playerScore; //The main player score
var cpuScore; //The CPU score
var cpuSpeed=6; //The speed of the CPU paddle; the faster it is the harder the game is


// Variables
 
var xSpeed = 2;
var ySpeed = 2;


var maxScore = "3";

var gameStarted = false;
var isMaster = false;

var TitleView = new createjs.Container();
var socket;

function Main()
{
    /* Link Canvas */
     
    stage = new createjs.Stage(document.getElementById('PongStage'));
         
    stage.mouseEventsEnabled = true;
    
 
    manifest = [
                {src:"assets/images/bg.png", id:"bg"},
                {src:"assets/images/main.png", id:"main"},
                {src:"assets/images/startB.png", id:"startB"},
                {src:"assets/images/creditsB.png", id:"creditsB"},
                {src:"assets/images/credits.png", id:"credits"},
                {src:"assets/images/paddle.png", id:"slavePlayer"},
                {src:"assets/images/paddle.png", id:"masterPlayer"},
                {src:"assets/images/ball.png", id:"ball"},
                {src:"assets/images/win.png", id:"win"},
                {src:"assets/images/lose.png", id:"lose"},
                {src:"assets/audio/playerScore.mp3", id:"playerScore"},
                {src:"assets/audio/enemyScore.mp3", id:"enemyScore"},
                {src:"assets/audio/hit.mp3", id:"hit"},
                {src:"assets/audio/wall.mp3", id:"wall"}
            ];
 
    
    queue = new createjs.LoadQueue();
    queue.installPlugin(createjs.Sound);
    //queue.on("progress", handleProgress);
    queue.on("complete", handleComplete);
    queue.on("fileload", handleFileLoad);
    queue.loadManifest(manifest);
 
    /* Ticker */
     
    createjs.Ticker.addEventListener("tick", handleTick);
    createjs.Ticker.setFPS(60);
}

function handleProgress(event)
{
    //use event.loaded to get the percentage of the loading
}
 
function handleComplete(event) {
         //triggered when all loading is complete
        stage.addChild(bg);
        $('#socket-status').html('connecting!');

        socket = io.connect('http://localhost:8080/');
        socket.on('connect', function () {
            addTitleView();
	    socket.on('status', function (status) {
		    
		switch (status){
                    case "wait":
                        $('#socket-status').html('waing for opponent!');
                        isMaster = true;
                        break;
                    
                    case "full":
                        $('#socket-status').html('game is busy!');
                        break;
                    
                    case "opponent-left":
                        $('#socket-status').html('oppenet left!');
                        gameStarted = false;
                        break;
                    
                    case "ready":
                        $('#socket-status').html('ready to play! master='+isMaster);
                        tweenTitleView();
                        
                        
                        socket.on('gameUpdate', function(data){
                            if (gameStarted) {
                                if (!isMaster) {
                                    masterPlayer.y = data.playerY;

                                    ball.x = data.ballX;
                                    ball.y = data.ballY;
                                }else{
                                    slavePlayer.y = data.playerY;
                                }
                                
                                
                                
                            }
                        });
                        
                        socket.on('gameEvent', function(data){
                            checkEvent(data.event);
                        });
                        break;
        

                    
                }
	    });
  	});
}
 
function handleFileLoad(event) {
         //triggered when an individual file completes loading
             
         if(event.item.type == "image")
         {
            //image loaded
             var img = new Image();
            img.src = event.item.src;
            window[event.item.id] = new createjs.Bitmap(img); 
          
         }
}

function showLoginView() {
    //code
}

function addTitleView()
{
    //console.log("Add Title View");
    //startB = new createjs.Bitmap(queue.getResult("startB"));
    startB.x = 240 - 31.5;
    startB.y = 160;
    startB.name = 'startB';
     
    //creditsB = new createjs.Bitmap(queue.getResult("creditsB"));
    creditsB.x = 241 - 42;
    creditsB.y = 200;
    
    //main = new createjs.Bitmap(queue.getResult("main"));
        

     
    TitleView.addChild(main, startB, creditsB);
    stage.addChild(TitleView);
     
    // Button Listeners
     
    creditsB.addEventListener("click",showCredits);
}

function showCredits()
{
    // Show Credits
    credits.x = 480;
         
    stage.addChild(credits);
    stage.update();
    createjs.Tween.get(credits).to({x:0}, 300);
    credits.addEventListener("click", hideCredits);
}
 
// Hide Credits
 
function hideCredits(e)
{
    createjs.Tween.get(credits).to({x:480}, 300).call(rmvCredits);
}
 
// Remove Credits
 
function rmvCredits()
{
    stage.removeChild(credits);
}
 
// Tween Title View
 
function tweenTitleView()
{       
    // Start Game
         
    createjs.Tween.get(TitleView).to({y:-320}, 300).call(addGameView);
}

function addGameView()
{
    // Destroy Menu & Credits screen
     
    stage.removeChild(TitleView);
    TitleView = null;
    credits = null;
     
    // Add Game View
     
    masterPlayer.x = 2;
    masterPlayer.y = 160 - 37.5;
    slavePlayer.x = 480 - 25;
    slavePlayer.y = 160 - 37.5;
    ball.x = 240 - 15;
    ball.y = 160 - 15;
     
    // Score
     
    playerScore = new createjs.Text('0', 'bold 20px Arial', '#A3FF24');
    playerScore.x = 211;
    playerScore.y = 20;
     
    cpuScore = new createjs.Text('0', 'bold 20px Arial', '#A3FF24');
    cpuScore.x = 262;
    cpuScore.y = 20;
     
    stage.addChild(playerScore, cpuScore, masterPlayer, slavePlayer, ball);
     
    // Start Listener 
     
    bg.addEventListener("click", startGame);
}

function startGame(e)
{
    if (isMaster) {
        socket.emit('gameEvent',{'event':'start'});
    }
    bg.removeEventListener("click", startGame);
    stage.addEventListener("stagemousemove", movePaddle);
    
    gameStarted = true;
}

function movePaddle(e)
{
    // Mouse Movement
    if(isMaster)
        masterPlayer.y = e.stageY;
    else
        slavePlayer.y = e.stageY;
}
 
/* Reset */
 
function reset()
{
    ball.x = 240 - 15;
    ball.y = 160 - 15;
    masterPlayer.y = 160 - 37.5;
    slavePlayer.y = 160 - 37.5;
     
    stage.removeEventListener("mousemove", movePaddle);
    gameStarted = false;
    bg.addEventListener("click", startGame);
}

function alert(e)
{
    stage.removeEventListener("mousemove", movePaddle);
    gameStarted = false;
    bg.removeEventListener("click", startGame);
     
    if(e == 'win')
    {
        win.x = 140;
        win.y = -90;
     
        stage.addChild(win);
        createjs.Tween.get(win).to({y: 115}, 300);
    }
    else
    {
        lose.x = 140;
        lose.y = -90;
     
        stage.addChild(lose);
        createjs.Tween.get(lose).to({y: 115}, 300);
    }
}

function doWallCollision() {
    ySpeed = -ySpeed;
    createjs.Sound.play('wall');
}

function doSlaveScore() {
    xSpeed = -xSpeed;
    cpuScore.text = parseInt(cpuScore.text + 1);
    reset();
    createjs.Sound.play('enemyScore');
}

function doMasterScore(){
    xSpeed = -xSpeed;
    playerScore.text = parseInt(playerScore.text + 1);
    reset();
    createjs.Sound.play('playerScore');
}

function doPlayerCollision(){
    xSpeed *= -1;
    createjs.Sound.play('hit');
}

function gameLoopUpdate(){
    
    /* Stop Paddle from going out of canvas */
     
    if(masterPlayer.y >= 249)
    {
        masterPlayer.y = 249;
    }
    if(slavePlayer.y >= 249)
    {
        slavePlayer.y = 249;
    }
     
     
    if (isMaster) {
            ball.x = ball.x + xSpeed;
            ball.y = ball.y + ySpeed;
            
            socket.emit('gameUpdate',
                {'playerY':masterPlayer.y,
                'ballX':ball.x,
                'ballY':ball.y
                });
            
            // Wall Collision 
 
            if((ball.y) < 0) {
                doWallCollision();
                socket.emit('gameEvent',{'event':'wallCollision'});
            };//Up
            if((ball.y + (30)) > 320) {
                doWallCollision();
                socket.emit('gameEvent',{'event':'wallCollision'});

            };//down
             
            /* CPU Score */
             
            if((ball.x) < 0)
            {
                doSlaveScore();
                socket.emit('gameEvent',{'event':'slaveScore'});
            }
             
            /* Player Score */
             
            if((ball.x + (30)) > 480)
            {
                doMasterScore();
                socket.emit('gameEvent',{'event':'masterScore'});

            }
             
            /* Cpu collision */
             
            if(ball.x + 30 > slavePlayer.x && ball.x + 30 < slavePlayer.x + 22 && ball.y >= slavePlayer.y && ball.y < slavePlayer.y + 75)
            {
                doPlayerCollision();
                socket.emit('gameEvent',{'event':'playerCollision'});

                
            }
             
            /* Player collision */
             
            if(ball.x <= masterPlayer.x + 22 && ball.x > masterPlayer.x && ball.y >= masterPlayer.y && ball.y < masterPlayer.y + 75)
            {
               doPlayerCollision();
                socket.emit('gameEvent',{'event':'playerCollision'});
            }
            /* Check for Win */
     
            if(playerScore.text == maxScore)
            {
                alert('win');
                socket.emit('gameEvent',{'event':'masterWon'});
            }
             
            /* Check for Game Over */
             
            if(cpuScore.text == maxScore)
            {

                alert('lose');
                socket.emit('gameEvent',{'event':'slaveWon'});

            }
     
    }
    else{
        
        socket.emit('gameUpdate',{'playerY':slavePlayer.y});

    }

    
    
}

function checkEvent(event){
    switch (event) {
        case 'start':
            startGame(event)
            break;
        case 'wallCollision':
            doWallCollision();
            break;
        case 'slaveScore':
            doSlaveScore();
            break;
        case 'masterScore':
            doMasterScore();

            break;
        case 'playerCollision':
            doPlayerCollision();
            break;
        case 'masterWon':
            alert('lose');
            break;
        case 'slaveWon':
            alert('win');
            break;

    }
}

function handleTick(e) {
    stage.update();
    if (gameStarted) {
        gameLoopUpdate();
    }

}