var app = require('http').createServer(handler);
var io = require('socket.io').listen(app);
var fs = require('fs');
var url = require("url"); 

app.listen(8080);

function handler (req, res) {
    var _path =  url.parse(req.url, true).pathname;
    
    fs.readFile(__dirname + _path, function (err, data) {
        if (err) {
          res.writeHead(500);
          return res.end('Error loading index.html');
        }
        res.writeHead(200);
        res.end(data);
    });
}

var client1 = -1;
var client2 = -1;

io.sockets.on('connection', function (socket) {
    console.log('client request:'+socket.id);
    
    console.log('STATUS cl1:'+client1.id+"  cl2:"+client2.id);


    if (client1 == -1) {
        client1 = socket;
        client1.emit('status','wait');
        console.log('SATUS cl1:'+client1.id+"  cl2:"+client2.id);

    }else if (client2 == -1) {
        client2 = socket;
        client1.emit('status', 'ready');
        client2.emit('status', 'ready');
        console.log('SATUS cl1:'+client1.id+"  cl2:"+client2.id);

        client1.on('gameUpdate', function (data) {
            client2.emit('gameUpdate',data);
        });
        client1.on('gameEvent', function (data) {
            client2.emit('gameEvent',data);
        });
        
        client2.on('gameUpdate', function (data) {
            client1.emit('gameUpdate',data);
        });
        client2.on('gameEvent', function (data) {
            client1.emit('gameEvent',data);
        });
    }else{
      socket.send({'status':'full'});
    }
   
   socket.on('disconnect', function(){
    if (socket.id == client1.id) {
        client1 = -1;
        if(client2 != -1) client2.emit('status','opponent-left');
    }
    
    if (socket.id == client2.id) {
        client2 = -1;
        if(client1 != -1) client1.emit('status','opponent-left');

    }
    console.log('STATUS cl1:'+client1.id+"  cl2:"+client2.id);

  });
  
});

